Problem LinkAuthor: Dmytro Berezin Tester: Pawel Kacprzak and Misha Chorniy Editorialist: Bhuvnesh Jain DifficultyEASYMEDIUM PrerequisitesSegment trees, Deque, Rotation trick ProblemYou are given an array $A$ consisting of 0 and 1. You need to perform 2 type of queries of the array.
Quick ExplanationRemove the rotation part in problem by duplicating the array. Precompute the answer for each window of size less than or equal to $k$. Use segment trees to answer the maximum in a range. ExplanationLet us first remove the query regarding rotation from the problem. This is a known trick where we remove the rotation using duplication of the array. To consider this aspect, see this example below : Let array $A$ be $\{1, 0, 0, 1, 1\}$. Duplicate this array i.e. $\{1, 0, 0, 1, 1, 1, 0, 0, 1, 1\}$ and call it as $B$. Now, you can see that we can obtain all the arrays possible after rotation. They are just contiguous subarrays of length $n$ in the above array $B$. For example, after 2 rotations, we can consider the subarray from position 3 to 7 as the required array. (0based indexing) Now, for the rotation query, we just need to handle the starting position in the above array $B$. So, these queries can be handled in $O(1)$ Once, we have removed the rotations part from the problem, we can precompute the number of 1's in window of size $k$ for all subarrays in $B$. Also, since we want to maximise the number of 1's in the frame, we can always greedily chose frame of size $k$ only. Doing this in a naive way will take complexity $O(n^2)$, as we will loop over subarrays and each subarray will take $O(n)$ in worst case. We can using sliding window concept here to calculate the number of ones in all frames of size $k$. The logic behind this is as follows : First we compute the answer for all positions which are less the $k$. After that, suppose we want to find the answer for a position starting at, say $x$ and ending at $(x+k1)$. We see that only one element moves out of the window and only one element enters the windows as we slide it. Thus, these operations can be done in $O(n)$. Below is a pseudo code for it.
For the sample array $B$ given above and choosing $k = 3$, the sum array will look like $\{1, 1, 1, 1, 2, 3, 2, 1, 1, 2\}$. Now, once we have calculated all the above sums, the question just reduces to finding the windows with maximum sum. Now, if the window is of size greater than or equal to the array size, then the answer is always the number of ones in the array else the answer is the maximum sum we can obtain by starting the window from $1$ to $(nk+1)$. These range maximum queries can be easily with segment trees, sparse tables or in this specific cases using deques. For handling the above minimum queries using segment trees or sparse table, one can refer to this editorial at topcoder . For understanding a better algorithm, which uses deque and works in $O(n)$, one can refer to this problem from Spoj. Time Complexity$O(n \log{n})$, if using segment trees / sparse tables $O(n)$ if using deques Solution Links
This question is marked "community wiki".
asked 18 May '17, 13:46

Solution:https://www.codechef.com/viewsolution/13617713 Concept:http://www.geeksforgeeks.org/slidingwindowmaximummaximumofallsubarraysofsizek/ Time complexity: O(n) Space complexity: O(n)(dynamic programming) + O(k) (for dequeue where k is frame size) I converted this problem to one where we have to find maximum in window of size k along with principle of dynamic programming. Main task is you have to generate array containing total one's in a window. You can see my solution. I got full 100 points. answered 18 May '17, 16:22

O(n) solution can be done without deques, using frequency table to get the max. Since values are 0 and 1 only, the max value changes by at most 1. answered 19 May '17, 10:13

this was a nice question and definitely not a easy one, I wonder how it got so many submissions,Please check for any cases of plagiarism or cheating. answered 18 May '17, 15:32

i used a heap since i didn't know segmented trees. and initially before rotation two pointers one at k1(0 based) and n1, subtract the pointers whenever rotation occurs and add n1 whenever the become less than 0. Avoids the use of B. answered 18 May '17, 15:44

I solved this problem without using segment tree, heap, deques, sparse table or any other special data structure. https://www.codechef.com/viewsolution/13623167 answered 18 May '17, 16:05

My segment tree solution was getting TLE. Here is the solution. Could someone please help in pointing out the error. Thanks in advance. answered 18 May '17, 16:18

I think it is wrong because you have not checked the condition when k will be greater than equal to n.Correct me if i am wrong. answered 18 May '17, 16:44

This was a great problem. I took the the deque approach after referring to this link. With some minor changes, and a check for k>n, it worked. For some reason though, my subtask testcases were failing with the deque, so I had to use brute force for n<1000. Here's my solution. answered 18 May '17, 17:05

@devilhector use iterative segment trees recursive calls on such high constraints is not gonna work. I've used the same approach you can view my solution https://www.codechef.com/viewsolution/13613563 answered 18 May '17, 17:12
recursive gave me 100
(18 May '17, 17:27)
I don't know how u got but mine was giving sigsegv and tle error on the recursive one
(18 May '17, 17:39)

https://www.codechef.com/viewsolution/13559652 solve this using priority queue and simple obserations answered 18 May '17, 17:41

@pkacprzak http://ideone.com/5xdql7 Please check this solution, it doesn't give the required answer on running! Used the recursive Segment trees! answered 18 May '17, 19:28
Please check this solution @chaitya_62
(22 May '17, 00:10)

https://www.codechef.com/viewsolution/13531464 I think it is better Approach ! :p answered 18 May '17, 23:39

I did this Question using sliding windows by precompute values and deque to get the maximum value answered 19 May '17, 09:20

Here is my solution: https://www.codechef.com/viewsolution/13634699 as same as author solution but I don't know why my solution got wrong. Please tell me why I got wrong. Thank you. answered 19 May '17, 14:26

One question guys! Is the complexity O(n) for the entire subtask or O(n) for each querie? answered 19 May '17, 19:16

Can someone tell me whats wrong with my code. I would be very greatful. Submission : https://www.codechef.com/viewsolution/13640002 answered 20 May '17, 12:52

This Solution is giving TLE. I have used Segment Tree/ Range Maximum Query. Please share your insight. answered 20 May '17, 22:52

A deque approach with window sliding and taking care of k>n condition and array sizes declaration gives an AC. here is my easy to understand solution easy solution answered 21 May '17, 10:10

I used trie https://www.codechef.com/viewsolution/13584501 answered 21 May '17, 15:21

i am using segment trees as said above . i am getting WA. please help me answered 23 May '17, 13:59

can anyone explain this part else the answer is the maximum sum we can obtain by starting the window from 1 to (n−k+1). answered 23 May '17, 14:16

Someone please tell me why my code is giving SIGABRT https://www.codechef.com/viewsolution/13742388 answered 23 May '17, 16:29

using namespace std; include<bits stdc++.h="">define _ iosbase::syncwith_stdio(false);cin.tie(NULL);define D(x) cout<< #x " = "<<(x)<<endl< h1="">int main() { _ int n;cin>>n; int acum = 0; int ans = 0; int t; for (int i = 0; i < n; ++i) { cin>>t; if (t == 0) { ans = max(ans, acum); acum = 0; } else { acum++; } } ans = max(ans, acum); cout<<ans<<endl;< p=""> return 0; } answered 23 May '17, 17:25

I have solved the same problem without using dequeue, segment tree or any sparse table. I have done it just by checking the contribution of the shifted 1 during the shift if last digit is 1 into the new forward window formed using that new 1 and removing its contribution from the last window formed earlier using that 1 digit. Similar is in case of a 0. To maintain the counts of 1's in the array used a multiset to store the counts of continuous 1's in the array after the shift. Answer will be the largest value in multiset whenever query occurs. Do check once! https://www.codechef.com/viewsolution/13527132 Thanks answered 23 May '17, 17:31

Can someone help me with my code, I'm getting WA in 2 test cases  one from small and one from large I've checked the condition for k>n using k = min(k,n). answered 23 May '17, 18:27

Can anyone reply with side cases and all the test cases you prepared for this problem. I need to run the code on those as its giving a WA. If anyone is willing to look at the code here is the link: https://www.codechef.com/viewsolution/13789471 The code is simple with no use of special data structures, easy to check. Thank you in advance :) answered 26 May '17, 15:16

Now its done. Still gives TLE in 34 cases. Code: https://www.codechef.com/viewsolution/13789884 answered 26 May '17, 16:11

My code is giving NZEC in certain cases. Can anyone please help why is this happening? class CHEFSUBA { public static void main(String[] args) throws IOException { boolean readFromFile = false; boolean outputToFile = false;
}
link
This answer is marked "community wiki".
answered 30 May '17, 02:49

My solution is showing TLE for few cases. Please help. answered 02 Jun '17, 11:36

My code is giving TLE. Please Help. https://www.codechef.com/viewsolution/13978376 answered 02 Jun '17, 11:38

can any1 give me d solution which is solved using sparse tables ?? answered 07 Jun '17, 22:22

@rj25 plz explain purpose of these lines : for(int k=nf;k>=0;k)frames.push_back(fr[k]); for(int i=n1;i>0;i)frames.push_back(fr[i]); in your code. answered 13 Jun '17, 22:48

The given pseudo code generates a different sum array..can anyone please explain how the given sum array is generated..@likecs @admin i think sum[0]=b[0] ..instead of sum[0]=0 answered 12 Aug '17, 12:45
How to compute the answer using this sum array...
(12 Aug '17, 20:26)
https://www.codechef.com/viewsolution/14939652 My simple and easy to understand solution.. And for all struggling with the "Sum array " part...sum[i] denotes the number of 1 in the range inp[ik] to inp[i]...
(12 Aug '17, 23:47)

I took a different analytical approach that was O(n). I will post it in sometime when I have completed drafting it.